<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Izg 2018 - 2019, lab 6.: student/camera.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Izg 2018 - 2019, lab 6.
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="examples.html"><span>Examples</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_df997ef5cbe81af8266600b381d65502.html">student</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">camera.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="camera_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#ifdef __cplusplus</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include&lt;<a class="code" href="fwd_8h.html">student/fwd.h</a>&gt;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keywordtype">void</span> <a class="code" href="camera_8h.html#a9ae73100cfea5804280d19ffbafb7f07">frustum_Mat4</a>(</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <a class="code" href="structMat4.html">Mat4</a>  *<span class="keyword">const</span> output,</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keywordtype">float</span>  <span class="keyword">const</span> left  ,</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordtype">float</span>  <span class="keyword">const</span> right ,</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keywordtype">float</span>  <span class="keyword">const</span> bottom,</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">float</span>  <span class="keyword">const</span> top   ,</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">float</span>  <span class="keyword">const</span> near  ,</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordtype">float</span>  <span class="keyword">const</span> far   );</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="keywordtype">void</span> <a class="code" href="camera_8h.html#a8da2a3e8adaa5a3515f7eecb5eb50de4">perspective_Mat4</a>(</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <a class="code" href="structMat4.html">Mat4</a>  *<span class="keyword">const</span> output,</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keywordtype">float</span>  <span class="keyword">const</span> fovy  ,</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keywordtype">float</span>  <span class="keyword">const</span> aspect,</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keywordtype">float</span>  <span class="keyword">const</span> near  ,</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordtype">float</span>  <span class="keyword">const</span> far   );</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="keywordtype">void</span> <a class="code" href="camera_8h.html#a9401b0642b138bef78433f5cedc6cea5">cpu_computeOrbitCamera</a>(</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <a class="code" href="structMat4.html">Mat4</a> *<span class="keyword">const</span> <a class="code" href="mouseCamera_8c.html#ae64ebe4c77936fc93d161b97bd8e96df">viewMatrix</a>,</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keywordtype">float</span> <span class="keyword">const</span> angleX    ,</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keywordtype">float</span> <span class="keyword">const</span> angleY    ,</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordtype">float</span> <span class="keyword">const</span> distance  );</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="keywordtype">void</span> <a class="code" href="camera_8h.html#aee672720f53cc1451803c545a9132956">cpu_getCameraPositionFromViewMatrix</a>(</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <a class="code" href="structVec3.html">Vec3</a>      *<span class="keyword">const</span> <a class="code" href="mouseCamera_8c.html#a2ae2553412ead34e3a4e23019d4f052e">cameraPosition</a>,</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <a class="code" href="structMat4.html">Mat4</a> <span class="keyword">const</span>*<span class="keyword">const</span> <a class="code" href="mouseCamera_8c.html#ae64ebe4c77936fc93d161b97bd8e96df">viewMatrix</a>    );</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="preprocessor">#ifdef __cplusplus</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;}</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="fwd_8h_html"><div class="ttname"><a href="fwd_8h.html">fwd.h</a></div><div class="ttdoc">This file contains forward declarations and constants. </div></div>
<div class="ttc" id="structVec3_html"><div class="ttname"><a href="structVec3.html">Vec3</a></div><div class="ttdoc">This struct represents column 3D vector of 32-bt floats. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.h:27</div></div>
<div class="ttc" id="camera_8h_html_a8da2a3e8adaa5a3515f7eecb5eb50de4"><div class="ttname"><a href="camera_8h.html#a8da2a3e8adaa5a3515f7eecb5eb50de4">perspective_Mat4</a></div><div class="ttdeci">void perspective_Mat4(Mat4 *const output, float const fovy, float const aspect, float const near, float const far)</div><div class="ttdoc">This functions initializes matrix to perspective matrix. </div><div class="ttdef"><b>Definition:</b> camera.c:43</div></div>
<div class="ttc" id="camera_8h_html_a9ae73100cfea5804280d19ffbafb7f07"><div class="ttname"><a href="camera_8h.html#a9ae73100cfea5804280d19ffbafb7f07">frustum_Mat4</a></div><div class="ttdeci">void frustum_Mat4(Mat4 *const output, float const left, float const right, float const bottom, float const top, float const near, float const far)</div><div class="ttdoc">This functions initializes matrix to general perspective matrix. </div><div class="ttdef"><b>Definition:</b> camera.c:13</div></div>
<div class="ttc" id="mouseCamera_8c_html_ae64ebe4c77936fc93d161b97bd8e96df"><div class="ttname"><a href="mouseCamera_8c.html#ae64ebe4c77936fc93d161b97bd8e96df">viewMatrix</a></div><div class="ttdeci">Mat4 viewMatrix</div><div class="ttdoc">This variable contains view matrix of orbit camera. </div><div class="ttdef"><b>Definition:</b> mouseCamera.c:46</div></div>
<div class="ttc" id="camera_8h_html_a9401b0642b138bef78433f5cedc6cea5"><div class="ttname"><a href="camera_8h.html#a9401b0642b138bef78433f5cedc6cea5">cpu_computeOrbitCamera</a></div><div class="ttdeci">void cpu_computeOrbitCamera(Mat4 *const viewMatrix, float const angleX, float const angleY, float const distance)</div><div class="ttdoc">This function computes view matrix of orbit camera manipulator. </div><div class="ttdef"><b>Definition:</b> camera.c:55</div></div>
<div class="ttc" id="camera_8h_html_aee672720f53cc1451803c545a9132956"><div class="ttname"><a href="camera_8h.html#aee672720f53cc1451803c545a9132956">cpu_getCameraPositionFromViewMatrix</a></div><div class="ttdeci">void cpu_getCameraPositionFromViewMatrix(Vec3 *const cameraPosition, Mat4 const *const viewMatrix)</div><div class="ttdoc">This function gets camere position from view matrix. </div><div class="ttdef"><b>Definition:</b> camera.c:72</div></div>
<div class="ttc" id="mouseCamera_8c_html_a2ae2553412ead34e3a4e23019d4f052e"><div class="ttname"><a href="mouseCamera_8c.html#a2ae2553412ead34e3a4e23019d4f052e">cameraPosition</a></div><div class="ttdeci">Vec3 cameraPosition</div><div class="ttdoc">This variable contains camera position in world-space. </div><div class="ttdef"><b>Definition:</b> mouseCamera.c:50</div></div>
<div class="ttc" id="structMat4_html"><div class="ttname"><a href="structMat4.html">Mat4</a></div><div class="ttdoc">This struct represents 4x4 matrix - it is represented by 4 column vectors. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.h:41</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Apr 24 2019 08:37:08 for Izg 2018 - 2019, lab 6. by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.9.1
</small></address>
</body>
</html>
